/* SPDX-License-Identifier: BSD-3-Clause */

#ifndef __SO_CONSUMER_H__
#define __SO_CONSUMER_H__

#include "ring_buffer.h"
#include "packet.h"

typedef struct so_consumer_ctx_t {
	struct so_ring_buffer_t *producer_rb;

	const char *out_file_name;
	int thread_number;
    /* TODO: add synchronization primitives for timestamp ordering */
	pthread_mutex_t dequeue_access_mutex;
} so_consumer_ctx_t;

typedef struct writer_data_t {
	int rez;
	unsigned long hash;
	unsigned long timestamp;
	int status;
} writer_data_t;



// common functions
int create_consumers(pthread_t *tids,
					int num_consumers,
					so_ring_buffer_t *rb,
					const char *out_filename);

int create_sorter(pthread_t *thread_id,
					 int num_consumers,
					 struct so_ring_buffer_t *rb,
					 const char *out_filename);

void destroy_remainings(void);

void set_common_variables(int outus_fd, int thrd_cnt);

#endif /* __SO_CONSUMER_H__ */
